/* gcp-symbol-browser-support.c generated by valac 0.19.0, the Vala compiler
 * generated from gcp-symbol-browser-support.vala, do not modify */

/*
 * This file is part of gedit-code-assistant.
 *
 * Copyright (C) 2011 - Jesse van den Kieboom
 *
 * gedit-code-assistant is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gedit-code-assistant is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gedit-code-assistant.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>


#define GCP_TYPE_DOCUMENT (gcp_document_get_type ())
#define GCP_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GCP_TYPE_DOCUMENT, GcpDocument))
#define GCP_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GCP_TYPE_DOCUMENT, GcpDocumentClass))
#define GCP_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GCP_TYPE_DOCUMENT))
#define GCP_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GCP_TYPE_DOCUMENT))
#define GCP_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GCP_TYPE_DOCUMENT, GcpDocumentClass))

typedef struct _GcpDocument GcpDocument;
typedef struct _GcpDocumentClass GcpDocumentClass;

#define GCP_TYPE_SYMBOL_BROWSER_SUPPORT (gcp_symbol_browser_support_get_type ())
#define GCP_SYMBOL_BROWSER_SUPPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GCP_TYPE_SYMBOL_BROWSER_SUPPORT, GcpSymbolBrowserSupport))
#define GCP_IS_SYMBOL_BROWSER_SUPPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GCP_TYPE_SYMBOL_BROWSER_SUPPORT))
#define GCP_SYMBOL_BROWSER_SUPPORT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GCP_TYPE_SYMBOL_BROWSER_SUPPORT, GcpSymbolBrowserSupportIface))

typedef struct _GcpSymbolBrowserSupport GcpSymbolBrowserSupport;
typedef struct _GcpSymbolBrowserSupportIface GcpSymbolBrowserSupportIface;

#define GCP_TYPE_SYMBOL_BROWSER (gcp_symbol_browser_get_type ())
#define GCP_SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GCP_TYPE_SYMBOL_BROWSER, GcpSymbolBrowser))
#define GCP_SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GCP_TYPE_SYMBOL_BROWSER, GcpSymbolBrowserClass))
#define GCP_IS_SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GCP_TYPE_SYMBOL_BROWSER))
#define GCP_IS_SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GCP_TYPE_SYMBOL_BROWSER))
#define GCP_SYMBOL_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GCP_TYPE_SYMBOL_BROWSER, GcpSymbolBrowserClass))

typedef struct _GcpSymbolBrowser GcpSymbolBrowser;
typedef struct _GcpSymbolBrowserClass GcpSymbolBrowserClass;

struct _GcpSymbolBrowserSupportIface {
	GTypeInterface parent_iface;
	GcpSymbolBrowser* (*get_symbol_browser) (GcpSymbolBrowserSupport* self);
};



GType gcp_document_get_type (void) G_GNUC_CONST;
GType gcp_symbol_browser_get_type (void) G_GNUC_CONST;
GType gcp_symbol_browser_support_get_type (void) G_GNUC_CONST;
GcpSymbolBrowser* gcp_symbol_browser_support_get_symbol_browser (GcpSymbolBrowserSupport* self);


GcpSymbolBrowser* gcp_symbol_browser_support_get_symbol_browser (GcpSymbolBrowserSupport* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GCP_SYMBOL_BROWSER_SUPPORT_GET_INTERFACE (self)->get_symbol_browser (self);
}


static void gcp_symbol_browser_support_base_init (GcpSymbolBrowserSupportIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		 * Get symbol browser
		 *
		 * Get the symbol browser for the document
		 *
		 */
		g_object_interface_install_property (iface, g_param_spec_object ("symbol-browser", "symbol-browser", "symbol-browser", GCP_TYPE_SYMBOL_BROWSER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	}
}


/**
 * Interface for documents supporting symbol browsing
 *
 * This interface is implemented on a Gcp.Document when it supports symbol
 * browsing.
 *
 */
GType gcp_symbol_browser_support_get_type (void) {
	static volatile gsize gcp_symbol_browser_support_type_id__volatile = 0;
	if (g_once_init_enter (&gcp_symbol_browser_support_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GcpSymbolBrowserSupportIface), (GBaseInitFunc) gcp_symbol_browser_support_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gcp_symbol_browser_support_type_id;
		gcp_symbol_browser_support_type_id = g_type_register_static (G_TYPE_INTERFACE, "GcpSymbolBrowserSupport", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gcp_symbol_browser_support_type_id, GCP_TYPE_DOCUMENT);
		g_once_init_leave (&gcp_symbol_browser_support_type_id__volatile, gcp_symbol_browser_support_type_id);
	}
	return gcp_symbol_browser_support_type_id__volatile;
}



